<template>
    <div class="content__leftAnalitika">
        <div class="lastPage-createNewUser blacklist__form animated fadeInUp">
            <div class="topAllUser">
                <p class="text-bold">{{ $t('monitoring_ip.blacklist.title') }}</p>
            </div>
            <form action="" @submit.prevent="create">
                <div class="box__leftInput">
                    <div class="box-input">
                        <label for="ipField">{{ $t('monitoring_ip.blacklist.ip') }}</label>
                        <input type="text" id="ipField" v-model="form.ip">
                    </div>
                    <div class="box-input">
                        <label for="commentField">{{ $t('monitoring_ip.blacklist.comment') }}</label>
                        <input type="password" id="commentField" v-model="form.comment">
                    </div>
                </div>
                <button class="save_noBg" type="submit">{{ $t('monitoring_ip.blacklist.submit') }}</button>
            </form>
        </div>
        <div class="control-user__bottom blacklist__table">
            <div class="box-user__table--head wow fadeInUp">
                <p class="text-tabelHead">{{ $t('monitoring_ip.blacklist.table.ip') }}</p>
                <p class="text-tabelHead">{{ $t('monitoring_ip.blacklist.table.comment') }}</p>
                <p class="text-tabelHead">{{ $t('monitoring_ip.blacklist.table.date') }}</p>
                <p class="text-tabelHead"></p>
            </div>
            <item :item="item" v-for="item in items" :key="item.id" @reload="setPage(1)"/>
            <paginator
                :current-page="currentPage"
                :last-page="lastPage"
                :per-page="perPage"
                :items-count="total"
                @page-changed="setPage"
            />
        </div>
    </div>
</template>

<script>
    import {mapGetters} from "vuex";
    import Item from "../components/blacklist/Item";
    import laravelValidationErrorParse from "../mixins/laravelValidationErrorParse";

    export default {
        name: "Blacklist",
        mixins: [laravelValidationErrorParse],
        data(){
            return {
                form: {
                    ip: '',
                    comment: ''
                },
                currentPage: 0,
                lastPage: 0,
                perPage: 0,
                total: 0,
                page: 1,
                items: [],
            }
        },
        computed: {
            ...mapGetters([
                'axios'
            ])
        },
        methods: {
            create(){
                let form_data = Object.assign({
                    _token: this.csrf
                }, this.form);

                this.axios.post('blacklist', this.form)
                    .then(resp => resp.data)
                    .then(data => {
                        if(data.id){
                            this.setPage(1);
                            this.form = {
                                ip: '',
                                comment: '',
                            }
                        }else{
                            this.$swal(this.$t('ui.error'), data.message, 'error')
                        }
                    })
                    .catch((error) => {
                        this.displayErrorsSwal(error);
                    });
            },
            submit(){
                this.axios.get('blacklist', {
                    params: {
                        page: this.page
                    }
                })
                    .then(resp => resp.data)
                    .then(items => {
                        console.log(items);
                        this.currentPage = items.current_page;
                        this.lastPage = items.last_page;
                        this.perPage = items.per_page;
                        this.total = items.total;
                        this.items = items.data;
                    });
            },
            setPage(page){
                this.page = page;
                this.submit();
            },
        },
        created(){
            this.submit();
        },
        components: {
            Item
        }
    }
</script>

<style scoped lang="scss">
    .blacklist__form{
        width: calc(100% - (53px + 28px));
        padding: 37px 28px 53px 53px;
        box-shadow: 0 30px 50px rgba(215, 215, 215, 0.11);
        border-radius: 11px;
        background-color: #ffffff;
        margin-top: 42px;
        .topAllUser{
            display: flex;
            justify-content: space-between;
            align-items: center;
            margin-bottom: 20px;
            .text-bold{
                color: #383838;
                font-family: 'Geometria Bold';
                font-size: 14px;
                font-weight: 700;
                line-height: 15px;
            }
            .text-allUser{
                color: #bebebe;
                font-family: 'Geometria Bold';
                font-size: 14px;
                font-weight: 700;
                line-height: 15px;
                span {
                    color: #295bdb;
                }
            }
        }
        form {
            display: flex;
            justify-content: space-between;
            align-items: center;
            flex-wrap: wrap;
            .box__leftInput{
                display: flex;
                justify-content: space-between;
                align-items: center;
                flex-wrap: wrap;
                flex-basis: 72.4%;
                .box-input{
                    display: flex;
                    justify-content: space-between;
                    align-items: center;
                    flex-wrap: wrap;
                    flex-basis: 44%;
                    label {
                        color: #adadad;
                        font-family: 'Geometria Bold';
                        font-size: 14px;
                        font-weight: 700;
                        line-height: 15px;
                    }
                    input {
                        flex-basis: calc(65% - 15px);
                        padding-left: 15px;
                        outline: none;
                        box-shadow: none;
                        border: none;display: flex;
                        justify-content: flex-start;
                        align-items: center;
                        height: 52px;
                        border-radius: 8px;
                        background-color: #f0f0f0;
                        color: #808080;
                        font-size: 14px;
                        font-weight: 400;
                        line-height: 15.15px;
                    }
                }
            }
            .save_noBg{
                padding: 14px 58px;
                border-radius: 35px;
                border: 2px solid #3069e9;
                background-color: #ffffff;
                display: flex;
                justify-content: center;
                align-items: center;
                color: #3067e7;
                font-size: 14px;
                font-weight: 400;
                line-height: 15px;
                outline: none;
                cursor: pointer;
                transition-duration: 500ms;
                transition-property: background-color, color;
                &:hover{
                    background-color: #2b5ede;
                    color: #fff;
                }

            }
        }
    }
</style>
